puls=[0.001:0.001:pi/12];
z=exp(i*2*[0.001:0.001:pi/12]);
sys=filt(1,[1 -1],12);
[mag1,phase]=bode(sys,puls);

% mag1a=1-mag1;
% mag1b=1+mag1;
puls_norm=puls*6/pi;
% index=find(mag1a>0);
% mag1a=mag1a(:);
% mag1b=mag1b(:);
% 
% R=[2.2333   -0.4467];
% S=[1.0000   -0.3300    0.0000         0    0.0000         0    0.0000    0.0000   -0.6700];
% A=[1 -0.2];
% B=[0 0 0 0 0 0 0 0 1];
% 
% P=A;
% for i=1:1
%     P=conv(P,[1 -0.5]);
% end
% 
% [Rp,Sp,nrp,nsp]=bezoutd(A,B,[1 -1],1,P);
% 
% R=Rp
% S=conv(Sp,[1 -1])
% 
% AS=conv(A,S);
% BR=conv(B,R);
% P=AS+BR
% Syb=filt(BR,P,12);
Syb=filt([0 0.6271],[1 -0.3729],12);
[mag,phase]=bode(Syb,puls);
mag=mag(:);
% % 
% % 
plot(puls_norm,20*log10(mag),'k','linewidth',2)
% maximum=6*ones(length(puls),1);
% %delmarg=min(maximum,20*log10(mag1b));
% delmarg_idx=find(maximum>=20*log10(mag1b));
% modmarg_idx=find(maximum<=20*log10(mag1b));
% plot(puls_norm(modmarg_idx),maximum(modmarg_idx),'k:','linewidth',2)
hold on
% plot(puls_norm(index),20*log10(mag1a(index)),'k-.','linewidth',2)
% plot(puls_norm(delmarg_idx),20*log10(mag1b(delmarg_idx)),'k-.','linewidth',2)
% plot(puls_norm,20*log10(mag),'k','linewidth',2)

plot(puls_norm,20*log10(mag1(:)),'k:','linewidth',2)
title('Noise-output Sensitivity Function Template','FontSize',12,'FontWeight','Bold')
ylabel('Magnitude (dB)','FontSize',12,'FontWeight','Bold')
xlabel('Frequency (f/f_{s})','FontSize',12,'FontWeight','Bold')
text(0.25,-2.5,'Template for Delay margin {\Delta\tau} = T_{s}','FontSize',12,'FontWeight','Bold')
%text(0.395,-2.5,'{\Delta\tau} = ','FontSize',14,'FontWeight','Bold')
%text(0.415,-2.55,'T_{s}','FontSize',12,'FontWeight','Bold')
axis([0 0.5 -8 0])
grid on