time=linspace(0,20,21)';
for i=1:8
    num_sys=num2str(i);
    eval(['sys_' num_sys '=filt([0 ' num2str(1-(i*0.1+0.1)) '],[1 -' num2str((i*0.1+0.1)) '],1);'])
    [y,tout]=step(eval(['sys_' num_sys]),time);
    switch i
    case 1
        h_1=plot(time,y,'k--','Linewidth',2);  
    case 7
        h_7=plot(time,y,'k-.','Linewidth',2);
    case 8
        h_8=plot(time,y,'k-','Linewidth',2);    
    otherwise
        plot(time,y,'k-','Linewidth',1);
    end
    hold on
end
text(0.8,1.025,'a_{1} = -0.2','FontSize',12,'FontWeight','Bold')
text(6.8,0.725,'a_{1} = -0.8','FontSize',12,'FontWeight','Bold')
text(10.8,0.625,'a_{1} = -0.9','FontSize',12,'FontWeight','Bold')
%legend([h_1 h_7 h_8],'a_{1} = -0.2','a_{1} = -0.8','a_{1} = -0.9',4)
axis([0 20 0 1.1])
title('Step Responses','FontSize',12,'FontWeight','Bold')
xlabel('Time (t/T_{s})','FontSize',12,'FontWeight','Bold')
grid on



