w=0.01:(pi-0.01)/1000:pi;
index=[2 4 7];
for i=1:3
num_sys=num2str(i);
eval(['sys_' num_sys '=filt([0 ' num2str(1-(index(i)*0.1+0.1)) '],[1 -' num2str((index(i)*0.1+0.1)) '],1);'])
[m,p]=bode(eval(['sys_' num_sys]),w);
subplot(2,1,1)
eval(['h_' num_sys '=plot(w/(2*pi),20*log10(m(:)),''k-'',''Linewidth'',2)']);
hold on
subplot(2,1,2)
eval(['h__' num_sys '=plot(w/(2*pi),p(:),''k-'',''Linewidth'',2)']);
hold on
end
subplot(2,1,1)
title('Bode Diagrams','FontSize',12,'FontWeight','Bold')
ylabel('Magnitude (dB)','FontSize',12,'FontWeight','Bold')
set(gca,'YTick',[-20 -15 -10 -5 0])
set(h_1,'Linestyle','--');
set(h_2,'Linestyle','-.');
set(h_3,'Linestyle','-');
text(0.275,-2,'a_{1}=-0.3','FontSize',12,'FontWeight','Bold');
text(0.15,-7,'a_{1}=-0.5','FontSize',12,'FontWeight','Bold');
text(0.07,-12,'a_{1}=-0.8','FontSize',12,'FontWeight','Bold');
grid on
subplot(2,1,2)
xlabel('Frequency (f/f_{s})','FontSize',12,'FontWeight','Bold')
ylabel('Phase (deg)','FontSize',12,'FontWeight','Bold')
set(gca,'YTick',[-180 -135 -90 -45])
%legend([h__1 h__2 h__3],'a_{1}=-0.3','a_{1}=-0.5','a_{1}=-0.8',1)
set(h__1,'Linestyle','--');
set(h__2,'Linestyle','-.');
set(h__3,'Linestyle','-');
text(0.2,-60,'a_{1}=-0.3','FontSize',12,'FontWeight','Bold');
text(0.025,-110,'a_{1}=-0.5','FontSize',12,'FontWeight','Bold');
text(0.08,-120,'a_{1}=-0.8','FontSize',12,'FontWeight','Bold');
grid on



